local eventframe = CreateFrame("FRAME", "WPvPFrame");
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD");
eventframe:RegisterEvent("ADDON_LOADED");
eventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
eventframe:RegisterEvent("PLAYER_TARGET_CHANGED");
eventframe:RegisterEvent("PLAYER_REGEN_ENABLED");
eventframe:RegisterEvent("PLAYER_REGEN_DISABLED");
eventframe:RegisterEvent("ZONE_CHANGED_NEW_AREA");
eventframe:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
--ADDING SPECIAL NAMES
--Change name at beginning of eventHandler to nickname
--Change nickname back to name in UpgradeFrames function in FrameWidgets
--Set Icon to be special conditionally in function SetFrameColors and SetClassFrame and SetHealthBars and SetTargetFrames in FrameWidgets


--THINGS LEFT TO DO
--Finish the UI
--Fix the lag
--Show flags on bg players
--Show target count on players


ClassByName={} --Class, known or suspected, Spec
PlayerNamesDisplayed={}
PlayerTrinketTimes={ }
PlayerLastActive={ }
PlayerHealth={ }
PlayerMaxHealth={ }
PlayerTargetable={ }
PlayerNamesList={ }
PlayerIsTargeted={}
PlayerGuilds={}

StringMaxLength=30
NumberOfFramesActive=0
local LastUpdate=GetTime()
local LastFrameUpgrade=GetTime()
local LastBGCheck=GetTime()
BGPlayers=nil
CombatStatus=false
local LastCombatDrop=GetTime()
instancetype="login"
LagThreshold=1000 --Micro seconds
ThePlayersFaction=select(1, UnitFactionGroup("player"))


local function FormatName(name, realm)
	if name==nil then
		name=""
	elseif realm and realm~="" then
		name=name.."-"..realm
	end
	if string.find(name, "Nachta") then name="Nach'ta" end
	if not ShowServerWork and string.find(name, "-") then 
		local stop=strfind(name, "-")-1
		name=string.sub(name, 1, stop)
	end
	return name
end

function eventHandler(self, event, ...)
	if event=="COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, Event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, param1, param2, param3, param4, param5,
		param6, param7, param8, param9, param10, param11, param12=...
	--print("wierd", wierd, "event", event, "timestamp", timestamp, "Event", Event, "sourceGUID", sourceGUID, "sourceName", sourceName, "sourceFlags", sourceFlags, "destGUID", destGUID,
	--"destName", destName, "destFlags", destFlags,
	--"param1-9", param1, param2, param3, param4, param5, param6, param7, param8, param9, param10, param11, param12)
		if string.find(Event, "SWING")==nil and string.find(Event, "ENVIRONMENTAL")==nil then
			if sourceName then 
				if string.len(sourceName)>StringMaxLength then sourceName=string.sub(sourceName, 1, StringMaxLength) end 
				if string.find(sourceName, "Nachta") then sourceName="Nach'ta" end
				if not ShowServerWork and string.find(sourceName, "-") then 
					local stop=strfind(sourceName, "-")-1
					sourceName=string.sub(sourceName, 1, stop)
				end
			end
			if destName then 
				if string.len(destName)>StringMaxLength then sourceName=string.sub(destName, 1, StringMaxLength) end 
				if string.find(destName, "Nachta") then destName="Nach'ta" end
				if not ShowServerWork and string.find(destName, "-") then 
					local stop=strfind(destName, "-")-1
					destName=string.sub(destName, 1, stop)
				end
			end
			if sourceName and (string.find(sourceName, " ")==nil or string.find(sourceName, "-")) then
				if bit.band(sourceFlags, 0x00000400)==0x00000400 then --unit was a player
					if SpecDatabase[param2] then
						ClassByName[sourceName]={(SpecDatabase[param2])[1], true, (SpecDatabase[param2])[2]}
					elseif ClassByName[sourceName] then
						if not ClassByName[sourceName][3] then
							if SpellDatabase[param2] then
								ClassByName[sourceName]={(SpellDatabase[param2])[1], true, nil} --We know the class, but not the spec
							end
						end
					end
				end
			end
			if Event=="SPELL_CAST_SUCCESS" and (param2=="Every Man For Himself" or param2=="PvP Trinket") then
				PlayerTrinketTimes[sourceName]=GetTime()
				if PlayerNamesDisplayed[sourceName] then
					_G["PlayerFrame" .. sourceName .. "Trinket"].cooldown:SetCooldown(GetTime(), 120)
				end
			end
			
			if destName and bit.band(destFlags, 0x00000400)==0x00000400 then --unit was a player
				if bit.band(destFlags, 0x00000040)==0x00000040 then --unit was hostile
					if NamesOfCCSpells[param2] then
						if not (param2=="Rake" and (param1==155722 or param1==150017)) then
							if destName~=sourceName then
								if Event=="SPELL_AURA_APPLIED" or Event=="SPELL_AURA_REFRESHED" then
									AddCC(destName, param2, param1)
									WPVPFUpdateDR()
								elseif Event=="SPELL_AURA_REMOVED" then
									RemoveCC(destName, param2, param1)
									WPVPFUpdateDR()
								end
							end
						end
					end
				end
			end
			if sourceName and bit.band(sourceFlags, 0x00000400)==0x00000400 then --unit was a player
				if PlayerNamesDisplayed[sourceName]==nil then 
					PlayerHealth[sourceName]=nil
					PlayerMaxHealth[sourceName]=nil
					CalculateFrameHeights()
					if bit.band(sourceFlags, 0x00000040)==0x00000040 and (string.find(sourceName, " ")==nil or string.find(sourceName, "-")) then --unit was hostile
						AddFrame(sourceName)
						SortFrames(mainframe) 
						if not CombatStatus then AdjustFrameHeights() end
					end
				end
			end
			if bit.band(sourceFlags, 0x00000400)==0x00000400 then --unit was a player
				if sourceName then 
					PlayerLastActive[sourceName]=GetTime()
				end
			end
		end
		if bit.band(destFlags, 0x00000400)==0x00000400 then --unit was a player
			if destName then --player receiving damage or healing exists
				if PlayerHealth[destName] and PlayerLastActive[destName] then --Health has been seen of this player in the past.
					if string.find(Event, "SWING") or string.find(Event, "ENVIRONMENTAL") then
						param4=param1
						param5=param2
					end
					if PlayerHealth[destName]==0 and (GetTime()-PlayerLastActive[destName])>2 then --Player must have rezzed
						PlayerHealth[destName]=nil
						PlayerMaxHealth[destName]=nil
						PlayerLastActive[destName]=GetTime()-31
					elseif string.find(Event, "DAMAGE") then
						if param5>0 then 
							PlayerHealth[destName]=0
						else
							PlayerHealth[destName]=PlayerHealth[destName]-param4
						end
					elseif string.find(Event, "HEAL") then
						if param5>0 then
							PlayerHealth[destName]=PlayerMaxHealth[destName]
						else
							PlayerHealth[destName]=PlayerHealth[destName]+param4
						end
					end
					if PlayerHealth[destName] then
						if PlayerHealth[destName]<0 then PlayerHealth[destName]=1 end
						if PlayerHealth[destName]>PlayerMaxHealth[destName] then
							PlayerHealth[destName]=PlayerMaxHealth[destName]
						end
					end
				end
			end
		end
	elseif event=="PLAYER_TARGET_CHANGED" then
		SetTargetFrames()
	elseif event=="ADDON_LOADED" then
		if XSize==nil then XSize=190 end
		if YSize==nil then YSize=300 end
		if BackgroundFrameShow==nil then BackgroundFrameShow=true end
		if BGWork==nil then BGWork=true end
		if ArenaWork==nil then ArenaWork=false end
		if WPvPWork==nil then WPvPWork=true end
		if SortStyle==nil then SortStyle=1 end
		if HPStyle==nil then HPStyle=3 end
		if DRWork==nil then DRWork=true end
		if TrinketWork==nil then TrinketWork=true end
		if ClassIconWork==nil then ClassIconWork=true end
		if PercentageHPWork==nil then PercentageHPWork=true end
		if ShowServerWork==nil then ShowServerWork=false end
		if FrameHeight==nil then FrameHeight=27 end
		if FontSize==nil then FontSize=13 end
		if HPFont==nil then HPFont=8 end
		if ClickableFrames==nil then ClickableFrames=true end
		if HealersOnly==nil then HealersOnly=false end
		if RaidNoClick==nil then RaidNoClick=true end
		if TargetCountEnable==nil then TargetCountEnable=false end
		if StarchMode==nil then StarchMode=true end
		if mainframe==nil then
			--Create the main background frame
			MainFrameCreate()
			TargetFrameCreate()
			_G["PlayerButton" .. 1]=CreateFrame("Button", nil, mainframe, "SecureActionButtonTemplate")
			_G["PlayerButton" .. 1]:SetPoint("TOP",mainframe , "TOP")
			CurrentParent=mainframe
			CreateSpellTable()
			CreateClassTable()
			CreateSpecTable()
			CreateNameColors()
			CreateSpecWeights()
			CreateTargetColors()
		end
		if panel==nil then 
			panel=CreateFrame("Frame", "AddonPanel", UIParent);
			panel.name= "PredatorFrames WPvP Player Frames"
			panel.refresh=function(self)
				XSizeSlider:SetValue(XSize)
				YSizeSlider:SetValue(YSize)
				FSizeSlider:SetValue(FrameHeight)
				NameSizeSlider:SetValue(FontSize)
				HPTextSizeSlider:SetValue(HPFont)
				if not CombatStatus then AdjustFrameHeights() end
				mainframe:SetWidth(XSize)
				mainframe:SetHeight(YSize)
				--Put checkbox stuff here
			end
			InterfaceOptions_AddCategory(panel);
			ExplanationBoxCreate()
			--Create Checkboxes
			CheckboxCreate()
			--Create the Frame height slider
			FSliderCreate()
			--Create X axis slider
			XSliderCreate()
			--Create Y axis slider
			YSliderCreate()
			--Create a test button for addon creatino
			NameSliderCreate()
			HPSliderCreate()
			TestButtonCreate()
			--Create drop down menu for selecitng sort method
			DropDownCreate()
			DropDownCreate2()
			CreateTexts()
		end
		CombatStatus=UnitAffectingCombat("player")
		CurrentFrameHeight=FrameHeight
	elseif event=="PLAYER_REGEN_ENABLED" then
		--print("left combat")
		LastCombatDrop=GetTime()
		CombatStatus=false
		CalculateFrameHeights()
		AdjustFrameHeights()
		UpgradeFrames(true)
		SortFrames(mainframe)
	elseif event=="PLAYER_REGEN_DISABLED" then
		--print("entered combat")
		CombatStatus=true
	elseif event=="PLAYER_ENTERING_WORLD" or event=="ZONE_CHANGED_NEW_AREA" then
		instancetype=select(2, GetInstanceInfo())
		local maxplayers=select(5, GetInstanceInfo())
		if instancetype=="pvp" or instancetype=="arena" then 
			RemoveAllFrames()
			--print("the max number of players is", maxplayers)
		end
		--print("Zone type is", instancetype)
		BGPlayers=nil
		ThePlayersFaction=select(1, UnitFactionGroup("player"))
	elseif event=="UPDATE_BATTLEFIELD_SCORE" then
		RequestBattlefieldScoreData()
		BGPlayers={}
		--print("====UPDATE_BATTLEFIELD_SCORE====")
		--print("Found", GetNumBattlefieldScores(), "Players.")
		for i=1, GetNumBattlefieldScores() do
			local name, killingBlows, _, _, _, faction, _, class, _, _, _, _, _, _, _, spec=GetBattlefieldScore(i)
			name=FormatName(name)
			BGPlayers[name]=true
			--print("Found", name, "In the bg.")
			if class=="Shaman" and spec=="Restoration" then spec="RestorationS" end
			if class=="Death Knight" and spec=="Frost" then spec="FrostDK" end
			if class=="Paladin" and spec=="Holy" then spec="HolyP" end
			if class=="Paladin" and spec=="Protection" then spec="ProtectionP" end
			if class=="Druid" and spec=="Feral" then spec="Feral Combat" end
			--print(name, "is a", class, spec)
			ClassByName[name]={class, true, spec}
			if not PlayerNamesDisplayed[name] and not faction==ThePlayersFaction then AddFrame(name) end
		end
	end
end
local function updateHandler()
	if GetTime()-LastUpdate>0.25 then
		WPVPFUpdateDR()
		if UnitHealth("target") then
			local targetname, targetrealm=UnitName("target")
			local targetnamerealm
			if targetrealm then
				targetnamerealm=targetname .. "-" .. targetrealm
			else 
				targetnamerealm=targetname
			end
			if targetnamerealm then
				PlayerHealth[targetnamerealm]=UnitHealth("target")
				PlayerMaxHealth[targetnamerealm]=UnitHealthMax("target")
			end
		end
		UpdateTrinketDisplay()
		SetHealthBars()
		LastUpdate=GetTime()
		RefreshFrames()
	end
	if GetTime()-LastFrameUpgrade>1 then
		if (not CombatStatus or not ClickableFrames or (RaidNoClick and not (instancetype=="pvp") and not (instancetype=="arena") and UnitInRaid("player"))) and not (instancetype=="arena" or instancetype=="battleground" or instancetype=="pvp") then 
			RemoveOldFrames() 
			--print("removing old frames by updateHandler")
		end
		SortFrames(mainframe)
		UpgradeFrames(true)
		LastFrameUpgrade=GetTime()
		SetTargetFrames()
	end
	if instancetype=="pvp" and BGWork and (GetTime()-LastBGCheck)>5 then
		LastBGCheck=GetTime()
		--print("======BG Spec Info======")
		RequestBattlefieldScoreData()
		if GetNumBattlefieldScores()>0 then BGPlayers={} end
		--print("Found", GetNumBattlefieldScores(), "Players.")
		for i=1, GetNumBattlefieldScores() do
			local name, killingBlows, _, _, _, faction, _, class, _, _, _, rating, _, _, _, spec=GetBattlefieldScore(i)
			name=FormatName(name)
			if class=="Shaman" and spec=="Restoration" then spec="RestorationS" end
			if class=="Death Knight" and spec=="Frost" then spec="FrostDK" end
			if class=="Paladin" and spec=="Holy" then spec="HolyP" end
			if class=="Paladin" and spec=="Protection" then spec="ProtectionP" end
			if class=="Druid" and spec=="Feral" then spec="Feral Combat" end
			--print(name, "is a", class, spec)
			ClassByName[name]={class, true, spec}
			if not PlayerNamesDisplayed[name] and not faction==ThePlayersFaction then AddFrame(name) end
		end
		local ZoneName=GetInstanceInfo()
		local MaxPlayersOnBGTeam=10
		if not rating then 
			if ZoneName=="Eye of the Storm" then
				MaxPlayersOnBGTeam=15
			elseif ZoneName=="Arathi Basin" then
				MaxPlayersOnBGTeam=15
			elseif ZoneName=="Alterac Valley" then
				MaxPlayersOnBGTeam=40
			elseif ZoneName=="Isle of Conquest" then
				MaxPlayersOnBGTeam=40
			elseif ZoneName=="Deepwind Gorge" then
				MaxPlayersOnBGTeam=15
			elseif ZoneName=="Strand of the Ancients" then
				MaxPlayersOnBGTeam=15
			end
		end
		if NumberOfFramesActive>MaxPlayersOnBGTeam then
			local oldesttime=0
			local oldestname=nil
			local frame=mainframe
			if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
				frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
				repeat 
					health=select(1, frame:GetChildren())
					local name=health.name:GetText()
					local age=GetTime()-PlayerLastActive[name]
					if age>oldesttime then 
						oldesttime=age
						oldestname=name
					end
					if select(ChildrenFrames+1, frame:GetChildren()) then 
						frame=select(ChildrenFrames+1, frame:GetChildren()) 
					else
						frame=nil
					end
				until not frame
				RemoveFrame(oldestname)
				--print(oldestname, "was the oldest frame and there are", NumberOfFramesActive, "frames.")
				AdjustFrameHeights()
			end
		end
	end
end
eventframe:SetScript("OnEvent", eventHandler);
eventframe:SetScript("OnUpdate", updateHandler);





